Subject: Re: bug#56549: 28.1; Compilation failure for lib-src/seccomp-filter.c on x86_64 with 32 bit userspace

From: Philipp Stephani <[email-masked]>
Date: Fri, 15 Jul 2022 17:58:45 +0200

Am Fr., 15. Juli 2022 um 17:42 Uhr schrieb Philipp Stephani
<[email-masked]>:
>
> Am Do., 14. Juli 2022 um 08:47 Uhr schrieb Ulrich Mueller <[email-masked]>:
> >
> > Forwarding Gentoo bug https://bugs.gentoo.org/857906:
> >
> > i686-pc-linux-gnu-gcc     -I. -I../src -I../lib -I. -I./../src -I./../lib  -Wl,-O1 -Wl,--as-needed  -mtune=i686 -O2 -pipe  seccomp-filter.c \
> >   -lseccomp  -o seccomp-filter
> > In file included from seccomp-filter.c:62:
> > seccomp-filter.c: In function 'main':
> > ../lib/verify.h:213:41: error: static assertion failed: "verify (sizeof (long) == 8 && LONG_MIN == INT64_MIN && LONG_MAX == INT64_MAX)"
> >   213 | # define _GL_VERIFY(R, DIAGNOSTIC, ...) _Static_assert (R, DIAGNOSTIC)
> >       |                                         ^~~~~~~~~~~~~~
> > ../lib/verify.h:273:20: note: in expansion of macro '_GL_VERIFY'
> >   273 | # define verify(R) _GL_VERIFY (R, "verify (" #R ")", -)
> >       |                    ^~~~~~~~~~
> > seccomp-filter.c:173:3: note: in expansion of macro 'verify'
> >   173 |   verify (sizeof (long) == 8 && LONG_MIN == INT64_MIN
> >       |   ^~~~~~
> > ../lib/verify.h:213:41: error: static assertion failed: "verify (sizeof (void *) == 8)"
> >   213 | # define _GL_VERIFY(R, DIAGNOSTIC, ...) _Static_assert (R, DIAGNOSTIC)
> >       |                                         ^~~~~~~~~~~~~~
> > ...
> > seccomp-filter.c:175:3: note: in expansion of macro 'verify'
> >   175 |   verify (sizeof (void *) == 8);
> >       |   ^~~~~~
> > make[1]: *** [Makefile:435: seccomp-filter] Error 1
> > make[1]: *** Waiting for unfinished jobs....
> > make[1]: Leaving directory '/var/tmp/portage/app-editors/emacs-28.1/work/emacs-28.1/lib-src'
> > make: *** [Makefile:436: lib-src] Error 2
> >
> > This is on an x86_64 machine with 32 bit userspace.
> >
> >
> > AFAICS, the problem is that lib-src/seccomp-filter.c (line 173) tests
> > for a 64 bit userspace:
> >
> >   verify (sizeof (long) == 8 && LONG_MIN == INT64_MIN
> >           && LONG_MAX == INT64_MAX);
> >
> > However, lib_src/Makefile.in (line 203) tests for 64 bit hardware:
> >
> > ifeq ($(shell uname -m),x86_64)
> > [...]
> > SECCOMP_FILTER=1
> > endif
>
> Thanks for the report. Is there a good way to test for a 64-bit
> userspace? Probably we want both tests.

I've now tried fixing this with commit db259d8fd369e6036df782d5fe51723a68220074.